use v6.c;

use GLib::Raw::Traits;

class GIO::TypeManifest does TypeManifest {

  method manifest {
    %(
      GAppInfoMonitor          => 'GIO::AppInfoMonitor',
      GAppLaunchContext        => 'GIO::LaunchContext',
      GApplication             => 'GIO::Application',
      GApplicationCommandLine  => 'GIO::ApplicationCommandLine',
      GBufferedInputStream     => 'GIO::BufferedInputStream',
      GBufferedOutputStream    => 'GIO::BufferedOutputStream',
      GBytesIcon               => 'GIO::BytesIcon',
      GCancellable             => 'GIO::Cancellable',
      GCharsetConverter        => 'GIO::CharsetConverter',
      GConverterInputStream    => 'GIO::ConverterInputStream',
      GConverterOutputStream   => 'GIO::ConverterOutputStream',
      GCredentials             => 'GIO::Credentials',
      GDBusActionGroup         => 'GIO::DBus::ActionGroup',
      GDBusAuthObserver        => 'GIO::DBus::AuthObserver',
      GDBusConnection          => 'GIO::DBus::Connection',
      GDBusInterfaceSkeleton   => 'GIO::DBus::InterfaceSkeleton',
      GDBusMessage             => 'GIO::DBus::Message',
      GDBusMethodInvocation    => 'GIO::DBus::MethodInvocation',
      GDBusObjectManagerClient => 'GIO::DBus::ObjectManagerClient',
      GDBusObjectManagerServer => 'GIO::DBus::ObjectManagerServer',
      GDBusObjectProxy         => 'GIO::DBus::ObjectProxy',
      GDBusObjectSkeleton      => 'GIO::DBus::ObjectSkeleton',
      GDBusProxy               => 'GIO::DBus::Proxy',
      GDBusServer              => 'GIO::DBus::Server',
      GDataInputStream         => 'GIO::DataInputStream',
      GDataOutputStream        => 'GIO::DataOutputStream',
      GDesktopAppInfo          => 'GIO::DesktopAppInfo',
      GEmblem                  => 'GIO::Emblem',
      GEmblemedIcon            => 'GIO::EmblemedIcon',
      GFileAttributeInfoList   => 'GIO::FileAttributeInfoList',
      GFileAttributeMatcher    => 'GIO::FileAttributeMatcher',
      GFileEnumerator          => 'GIO::FileEnumerator',
      GFileIOStream            => 'GIO::FileIOStream',
      GFileIcon                => 'GIO::FileIcon',
      GFileInfo                => 'GIO::FileInfo',
      GFileInputStream         => 'GIO::FileInputStream',
      GFileMonitor             => 'GIO::FileMonitor',
      GFileOutputStream        => 'GIO::FileOutputStream',
      GFilenameCompleter       => 'GIO::FilenameCompleter',
      GFilterInputStream       => 'GIO::FilterInputStream',
      GFilterOutputStream      => 'GIO::FilterOutputStream',
      GIOStream                => 'GIO::Stream',
      GInetAddress             => 'GIO::InetAddress',
      GInetAddressMask         => 'GIO::InetAddressMask',
      GInetSocketAddress       => 'GIO::InetSocketAddress',
      GInputStream             => 'GIO::InputStream',
      GListStore               => 'GIO::ListStore',
      GMemoryInputStream       => 'GIO::MemoryInputStream',
      GMemoryOutputStream      => 'GIO::MemoryOutputStream',
      GMenu                    => 'GIO::Menu',
      GMenuAttributeIter       => 'GIO::MenuAttributeIter',
      GMenuItem                => 'GIO::MenuItem',
      GMenuLinkIter            => 'GIO::MenuLinkIter',
      GMenuModel               => 'GIO::MenuModel',
      GMountOperation          => 'GIO::MountOperation',
      GNetworkAddress          => 'GIO::NetworkAddress',
      GNetworkService          => 'GIO::NetworkService',
      GNotification            => 'GIO::Notification',
      GOutputStream            => 'GIO::OutputStream',
      GPermission              => 'GIO::Permission',
      GPropertyAction          => 'GIO::PropertyAction',
      GProxyAddress            => 'GIO::ProxyAddress',
      GProxyAddressEnumerator  => 'GIO::ProxyAddressEnumerator',
      GResolver                => 'GIO::Resolver',
      GResource                => 'GIO::Resource',
      GSettings                => 'GIO::Settings',
      GSettingsBackend         => 'GIO::SettingsBackend',
      GSettingsSchema          => 'GIO::SettingsSchema',
      GSimpleAction            => 'GIO::SimpleAction',
      GSimpleActionGroup       => 'GIO::SimpleActionGroup',
      GSimplePermission        => 'GIO::SimplePermission',
      GSimpleProxyResolver     => 'GIO::SimpleProxyResolver',
      GSocket                  => 'GIO::Socket',
      GSocketAddress           => 'GIO::SocketAddress',
      GSocketAddressEnumerator => 'GIO::SocketAddressEnumerator',
      GSocketClient            => 'GIO::SocketClient',
      GSocketConnection        => 'GIO::SocketConnection',
      GSocketControlMessage    => 'GIO::SocketControlMessage',
      GSocketListener          => 'GIO::SocketListener',
      GSocketService           => 'GIO::SocketService',
      GSrvTarget               => 'GIO::SrvTarget',
      GTask                    => 'GIO::Task',
      GTcpConnection           => 'GIO::TcpConnection',
      GTcpWrapperConnection    => 'GIO::TcpWrapperConnection',
      GThemedIcon              => 'GIO::ThemedIcon',
      GThreadedSocketService   => 'GIO::ThreadedSocketService',
      GTlsCertificate          => 'GIO::TlsCertificate',
      GTlsConnection           => 'GIO::TlsConnection',
      GTlsDatabase             => 'GIO::TlsDatabase',
      GTlsInteraction          => 'GIO::TlsInteraction',
      GTlsPassword             => 'GIO::TlsPassword',
      GUnixConnection          => 'GIO::UnixConnection',
      GUnixCredentialsMessage  => 'GIO::UnixCredentialsMessage',
      GUnixFDList              => 'GIO::UnixFDList',
      GUnixFDMessage           => 'GIO::UnixFDMessage',
      GUnixInputStream         => 'GIO::UnixInputStream',
      GUnixMountEntry          => 'GIO::UnixMount',
      GUnixOutputStream        => 'GIO::UnixOutputStream',
      GUnixSocketAddress       => 'GIO::UnixSocketAddress',
      GVfs                     => 'GIO::VFS',
      GVolumeMonitor           => 'GIO::VolumeMonitor',
      GZlibCompressor          => 'GIO::ZlibCompressor',
      GZlibDecompressor        => 'GIO::ZlibDecompressor'
    )
  }

}
